/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.gui;

import net.minecraft.entity.player.EntityPlayer;

import buildcraft.lib.tile.TileBC_Neptune;

public abstract class ContainerBCTile<T extends TileBC_Neptune> extends ContainerBC_Neptune {
    public final T tile;

    public ContainerBCTile(EntityPlayer player, T tile) {
        super(player);
        this.tile = tile;
        if (!tile.func_145831_w().field_72995_K) {
            tile.onPlayerOpen(player);
        }
    }

    @Override
    public void func_75134_a(EntityPlayer player) {
        super.func_75134_a(player);
        tile.onPlayerClose(player);
    }

    @Override
    public boolean func_75145_c(EntityPlayer player) {
        return tile.canInteractWith(player);
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();
        tile.sendNetworkGuiTick(this.player);
    }
}
