/* Copyright (c) 2016 SpaceToad and the BuildCraft team
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/. */
package buildcraft.transport;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.BlockPos;

public enum BCTransportGuis {
    FILTERED_BUFFER,
    PIPE_DIAMOND,
    PIPE_DIAMOND_WOOD,
    PIPE_EMZULI,
    GATE;

    public static final BCTransportGuis[] VALUES = values();

    public static BCTransportGuis get(int id) {
        if (id < 0 || id >= VALUES.length) return null;
        return VALUES[id];
    }

    public void openGui(EntityPlayer player) {
        openGui(player, 0, -1, 0);
    }

    public void openGui(EntityPlayer player, BlockPos pos) {
        openGui(player, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
    }

    public void openGui(EntityPlayer player, int x, int y, int z) {
        player.openGui(BCTransport.INSTANCE, ordinal(), player.func_130014_f_(), x, y, z);
    }
}
